Upstream-Status: Pending
From cd21b5a6fab8e6c812804fa263800d8328208c5c Mon Sep 17 00:00:00 2001
From: Ankush Mehtre <ankush.mehtre@amd.com>
Date: Mon, 28 Nov 2022 18:53:35 +0530
Subject: [PATCH 270/295] firmware: Convert deprecated strncpy to strscpy

Since strncpy is deprecated and it does not append null character at the
end, we are using strscpy, which will return no. of bytes it copied and it
will append null character at the end. And we are passing len-1 to strscpy
allocating last byte for null character.

The issue is also reported by sparse warning as "In 'strncpy' specified
bound 255 equals destination size."

Signed-off-by: Ankush Mehtre <ankush.mehtre@amd.com>
State: pending
---
 drivers/firmware/xilinx/zynqmp-secure.c | 11 +++++++----
 1 file changed, 7 insertions(+), 4 deletions(-)

diff --git a/drivers/firmware/xilinx/zynqmp-secure.c b/drivers/firmware/xilinx/zynqmp-secure.c
index fd73c84c4521..647887a4da45 100644
--- a/drivers/firmware/xilinx/zynqmp-secure.c
+++ b/drivers/firmware/xilinx/zynqmp-secure.c
@@ -31,10 +31,13 @@ static ssize_t secure_load_store(struct device *dev,
 	u64 dst, ret;
 	int len;
 
-	strncpy(image_name, buf, NAME_MAX);
-	len = strlen(image_name);
-	if (image_name[len - 1] == '\n')
-		image_name[len - 1] = 0;
+	len = strscpy(image_name, buf, NAME_MAX - 1);
+	if (len > 0) {
+		if (image_name[len - 1] == '\n')
+			image_name[len - 1] = 0;
+	} else {
+		return -E2BIG;
+	}
 
 	ret = request_firmware(&fw, image_name, dev);
 	if (ret) {
-- 
2.34.1

